<?php

namespace PointRetrait;

use Propel\Runtime\Connection\ConnectionInterface;
use Propel\Runtime\Propel;
use Thelia\Core\Translation\Translator;
use Thelia\Install\Database;
use Thelia\Model\Country;
use Thelia\Model\OrderPostage;
use Thelia\Module\AbstractDeliveryModule;
use Thelia\Module\Exception\DeliveryException;


class PointRetrait extends AbstractDeliveryModule
{
    /** @var string */
    const DOMAIN_NAME = 'pointretrait';
    const MESSAGE_DOMAIN = 'pointretrait';
    const MODULE_URL = '/admin/module/PointRetrait';


    /**
     * @param ConnectionInterface|null $con
     */
    public function postActivation(ConnectionInterface $con = null)
    {
        $database = new Database($con->getWrappedConnection());
        $database->insertSql(null, array(__DIR__ . '/Config/thelia.sql'));
    }


    /**
     * This method is called by the Delivery  loop, to check if the current module has to be displayed to the customer.
     * Override it to implements your delivery rules/
     *
     * If you return true, the delivery method will de displayed to the customer
     * If you return false, the delivery method will not be displayed
     *
     * @param Country $country the country to deliver to.
     *
     * @return boolean
     */
    public function isValidDelivery(Country $country)
    {
        return true;
    }


    /**
     * Calculate and return delivery price in the shop's default currency
     *
     * @param Country $country the country to deliver to.
     *
     * @return OrderPostage|float             the delivery price
     * @throws DeliveryException if the postage price cannot be calculated.
     */
    public function getPostage(Country $country)
    {
        if (! $this->isValidDelivery($country)) {
            throw new DeliveryException(
                Translator::getInstance()->trans("This module cannot be used on the current cart.")
            );
        }

        $price = 0;
        $con = Propel::getConnection();
//        $currentAddressId = $this->getRequest()->getSession()->getOrder()->getChoosenDeliveryAddress();
//        if (!empty($currentAddressId)) {
//            $zipcode = AddressQuery::create()->filterById($currentAddressId)->findOne($con)->getZipcode();
//            $areaId = LpsAreaCityQuery::create()->findOneByZipcode($zipcode)->getIdArea();
//            $price = LpsAreaQuery::create()->findOneById($areaId)->getPrice();
//        }

        return $price;
    }


    static public function getDayLabel($int)
    {
        $translator = Translator::getInstance();

        $days = [
            $translator->trans("Monday", [], PointRetrait::MESSAGE_DOMAIN),
            $translator->trans("Tuesday", [], PointRetrait::MESSAGE_DOMAIN),
            $translator->trans("Wednesday", [], PointRetrait::MESSAGE_DOMAIN),
            $translator->trans("Thursday", [], PointRetrait::MESSAGE_DOMAIN),
            $translator->trans("Friday", [], PointRetrait::MESSAGE_DOMAIN),
            $translator->trans("Saturday", [], PointRetrait::MESSAGE_DOMAIN),
            $translator->trans("Sunday", [], PointRetrait::MESSAGE_DOMAIN)
        ];

        if ($int === null)
            return $days;
        else
            return $days[$int];
    }

}
